import sum.kern.*;
import sum.werkzeuge.*;
/**
 * @author 
 * @version 
 */
public class Balken
{
    // Objekte
    int Timer = 0;
    Bildschirm derBildschirm;
    Buntstift hatStift;
    Maus dieMaus;
    Ball derBall;
    double Winkel;
    Rechner derRechner;
    int zBreite;
    double zGeschwindigkeit;    

    // Konstruktor
    /**
     * Der Balken ist unten am Spielfeld und soll den Ball vom Absturz abhalten und ihn ihm die Richtung zuweisen.
     * @param pBildschirm Bildschirm, der das Spielfeld begrenzt.
     * @param pMaus Die Maus soll bergeben werden.
     * @param pBreite Breite des Balken.
     * @param pGeschwindigkeit Pixel, die der Balken pro Durchgang zurcklegt.
     * @param pBall Der Ball muss bergeben werden.
     */
    public Balken(Bildschirm pBildschirm, Maus pMaus, int pBreite, double pGeschwindigkeit, Ball pBall)
    {
        derBildschirm = pBildschirm;
        hatStift = new Buntstift();
        zBreite = pBreite;
        hatStift.setzeLinienBreite(3);
        zGeschwindigkeit = pGeschwindigkeit;
        dieMaus = pMaus;
        derBall = pBall;
        derRechner = new Rechner();
    }

    // Dienste
    /**
     * Setzt den Balken an die angegebene Position.
     * @param x Horizontale Position
     * @param y Vertikale Position
     */
    public void bewegeBis(int x, int y){
        hatStift.hoch();
        hatStift.bewegeBis(x, y);
        hatStift.runter();
    }
    /**
     * ndert die Breite des Balkens.
     * @param Breite Die Breite in Pixel.
     */
    public void setzeBreite(int Breite){
        zBreite = Breite;
    }
    /**
     * Bewegt den Balken Richtung Maus um angegebene Pixel. Er lscht und zeichnet sich selbst nur, wenn er bewegt wird.
     */
    public void bewege(){
        if(derBall.vPosition() > hatStift.vPosition() - 8 && derBall.hPosition() + 5 > hatStift.hPosition() && derBall.hPosition() < hatStift.hPosition() + zBreite + 5){
            if(derBall.hPosition() > this.hPosition()){
                //Rechts
                Winkel = this.hPosition() - derBall.hPosition();
            }else{
                //Links
                Winkel = this.hPosition() - derBall.hPosition();
            }
            //Winkel muss nach oben ausgerichtet sein
            if(!derBall.nachUnten((derBall.Richtung() * (-1)) + Winkel)){
                derBall.setzeRichtung((derBall.Richtung() * (-1)) + Winkel);
                derBall.move();
            }else{
                derBall.setzeRichtung((derBall.Richtung() * (-1)));
                derBall.move();
            }
        }
        if(derRechner.betrag(dieMaus.hPosition() - this.hPosition()) > 5){
            this.loesche();
            hatStift.hoch();
            if(dieMaus.hPosition() < this.hPosition() && hatStift.hPosition() > 0){
                hatStift.bewegeUm((-1)*zGeschwindigkeit);
            }else if(hatStift.hPosition() < derBildschirm.breite() - zBreite){
                hatStift.bewegeUm(zGeschwindigkeit);
            }
            hatStift.runter();
            this.zeichne();
        }
    }
    /**
     * Gibt die horizontale Position der Balkenmitte aus.
     */
    public double hPosition(){
        return hatStift.hPosition() + (zBreite/2);
    }
    /**
     * Zeichnet den Balken mit der Dicke von 3 Pixel und einem Abstand von 3 Pixel zum unteren Rand in der angegebenen Breite.
     */
    public void zeichne(){
        hatStift.runter();
        hatStift.bewegeUm(zBreite);
        hatStift.bewegeUm((-1)*zBreite);
    }
    /**
     * Gibt die Breite des Balkens zurck.
     * @return Die Breite in Pixel.
     */
    public int Breite(){
        return zBreite;
    }
    /**
     * Lscht den Balken.
     */
    public void loesche(){
        hatStift.radiere();
        this.zeichne();
        hatStift.normal();
    }
    /**
     * ndert die Geschwindigkeit des Balkens (Empfindlichkeit)
     * @param speed Konstante, je hher, desto schneller.
     */
    public void setzeGeschwindigkeit(double speed){
        zGeschwindigkeit = speed;
    }
    /**
     * Gibt alle eigenen Klassen frei.
     */
    public void gibFrei()    {
        hatStift.gibFrei();
    }
}