
import sum.kern.*;
/**
 * @author 
 * @version 
 */
public class Brick
{
    // Objekte
    Bildschirm kenntBildschirm;
    Buntstift meinStift;
    Ball derBall;
    Counter derCounter;
    boolean active;
    int hPos;
    int vPos;

    // Konstruktor
    /**
     * Erstellt einen Brick
     * @param pBildschirm Der Bildschirm muss bergeben werden.
     * @param phPos horizontale Position des Bricks.
     * @param pvPos vertikale Position des Bricks.
     * @param pBall Bentigt den Ball, damit man weiss, wann der Brick zerstrt wird.
     * @param pCounter Bentigt den Counter, um die Punktzahl zu erhhen.
     */
    public Brick(Bildschirm pBildschirm, int phPos, int pvPos, Ball pBall, Counter pCounter)
    {
        kenntBildschirm = pBildschirm;
        derCounter = pCounter;
        derBall = pBall;
        meinStift = new Buntstift();
        hPos = phPos;
        vPos = pvPos;
        meinStift.bewegeBis(hPos, vPos);
        active = true;
    }

    // Dienste
    /**
     * Prft, ob der Brick mit dem Ball in Kontakt kommt. Der Ball prall im Einfallswinkel ab.
     */
    public void pruefe(){
        if(active){
            this.zeichne();
            //Wenn der Ball an einer AUSSENSEITE (2. Bedingung) ankommt, soll der Winkel verndert werden und der Brick zerstrt werden.
            if(this.links() && !derBall.nachLinks(derBall.Richtung())){
                if(!derBall.supermodus()){
                    derBall.setzeRichtung((derBall.Richtung() * (-1)) + 180);
                    derBall.move();
                }
                this.destroy();
            }
            if(this.rechts() && !derBall.nachRechts(derBall.Richtung())){
                if(!derBall.supermodus()){
                    derBall.setzeRichtung((derBall.Richtung() * (-1)) + 180);
                    derBall.move();
                }
                this.destroy();
            }
            if(this.unten() && !derBall.nachUnten(derBall.Richtung())){
                if(!derBall.supermodus()){
                    derBall.setzeRichtung(derBall.Richtung() * (-1));
                    derBall.move();
                }
                this.destroy();
            }
            if(this.oben() && !derBall.nachOben(derBall.Richtung())){
                if(!derBall.supermodus()){
                    derBall.setzeRichtung(derBall.Richtung() * (-1));
                    derBall.move();
                }
                this.destroy();
            }
        }
    }
    /**
     * Prft, ob der Brick noch nicht zerstrt wurde
     */
    public boolean aktiv(){
        if(active == true) return true;
        else return false;
    }
    /**
     * Deaktiviert den Brick, lscht den Brick.
     */
    public void destroy(){
        meinStift.radiere();
        if(active) derCounter.addiere();
        this.zeichne();
        active = false;
    }
    /**
     * Definiert die Farbe des Bricks
     */
    public void setzeFarbe(int Farbe){
        meinStift.setzeFarbe(Farbe);
    }
    /**
     * Zeichnet ein Rechteck mit den Massen 40 x 15 Pixel an der Position des Bricks. Ankerpunkt ist oben links.
     */
    public void zeichne()
    {
        if(active){
            meinStift.zeichneRechteck(40, 15);
        }
    }
    /**
     * Prft, ob der Ball unten am Brick ankommt.
     */
    public boolean unten(){
        return((derBall.hPosition() > hPos - 5 && derBall.hPosition() < hPos + 45) && (derBall.vPosition() <= vPos + 20 && derBall.vPosition() >= vPos + 17));
    }
    /**
     * Prft, ob der Ball oben am Brick ankommt.
     */
    public boolean oben(){
        return((derBall.hPosition() > hPos - 5 && derBall.hPosition() < hPos + 45) && (derBall.vPosition() >= vPos - 5 && derBall.vPosition() <= vPos - 2));
    }
    /**
     * Prft, ob der Ball links am Brick ankommt.
     */
    public boolean links(){
        return((derBall.hPosition() >= hPos - 5 && derBall.hPosition() <= hPos - 2) && (derBall.vPosition() > vPos - 5 && derBall.vPosition() < vPos + 20));
    }
    /**
     * Prft, ob der Ball rechts am Brick ankommt.
     */
    public boolean rechts(){
        return((derBall.hPosition() <= hPos + 45 && derBall.hPosition() >= hPos + 42) && (derBall.vPosition() > vPos - 5 && derBall.vPosition() < vPos + 20));
    }
    /**
     * Gibt alle eigenen Objekte frei.
     */
    public void gibFrei(){
         // Aufraeumen
        meinStift.gibFrei();
        kenntBildschirm.gibFrei();
    }
}