
import sum.kern.*;
import sum.werkzeuge.*;

/**
 * @author Dario, Amon
 * @version 23.06.10
 */
public class Hauptprogramm
{
    // Objekte
    Buntstift meinStift;
    Bildschirm derBildschirm;
    Ball derBall;
    Maus dieMaus;
    Uhr dieUhr;
    Counter derCounter;
    Balken derBalken;
    Level dasLevel;
    boolean win = false;
    int numLevel = 1;

    // Konstruktor
    public Hauptprogramm()
    {
        derBildschirm = new Bildschirm(500, 400);
        derBall = new Ball(derBildschirm);
        dieMaus = new Maus();
        dieUhr = new Uhr();
        meinStift = new Buntstift();
        derCounter = new Counter(derBildschirm);
        derBall.setzeBall(250,375);
        derBall.setzeRichtung(90);
        derBalken = new Balken(derBildschirm, dieMaus, 100, 1.3, derBall);
        derBalken.bewegeBis((derBildschirm.breite()/2)-(100/2), derBildschirm.hoehe()+20);
        dasLevel = new Level(derCounter, derBildschirm, derBall, numLevel, derBalken);
    }
      
    // Dienste
       /**
        * Startet das Spiel, beginnend beim ersten Level.
        */
    public void fuehreAus()
    {   
        dasLevel.zeichne();
        derBall.zeichne();
        derBalken.zeichne();
        while (!dieMaus.istGedrueckt()){
         ;   
        }
        while (!derBall.amUnterenRand() && !win)
        {
            dasLevel.pruefeBricks();
            if(dasLevel.fertig()){
                if(dasLevel.pruefe()){
                    numLevel++;
                    derCounter.setzeZurueck();
                    derBall.loesche();
                    derBall.setzeBall(250,375);
                    derBall.zeichne();
                    derBall.setzeRichtung(90);
                    derBalken.loesche();
                    dasLevel.gibFrei();
                    derBalken.zeichne();
                    dasLevel = new Level(derCounter, derBildschirm, derBall, numLevel, derBalken);
                    dasLevel.zeichne();
                    dasLevel.aktualisiere();
                    while(!dieMaus.istGedrueckt()){
                        ;
                    }
                }else{
                    win = true;
                }
            }
            dasLevel.aktualisiere();
            derBall.bewege();
            derBalken.bewege();
            dieUhr.warte(4);
        }
        if(dasLevel.fertig()){
            meinStift.bewegeBis(170, 170);
            meinStift.setzeFarbe(Farbe.ROT);
            meinStift.setzeLinienBreite(2);
            meinStift.setzeSchriftgroesse(20);
            meinStift.schreibeText("Sie haben gewonnen!");
        }
        
        // Aufraeumen
        derBalken.gibFrei();
        dasLevel.gibFrei();
        meinStift.gibFrei();
        derBildschirm.gibFrei();
        derBall.gibFrei();
        dieMaus.gibFrei();
        dieUhr.gibFrei();
    }
}