import sum.kern.*;
/**
 * @author Dario, Amon
 * @version 
 */
public class Level
{
    // Bezugsobjekte
    Counter derCounter;
    Balken derBalken;
    Bildschirm derBildschirm;
    Ball derBall;
    Buntstift meinStift;
    boolean win = false;
    int numBricks;
    int numLevel;
    int anzLevel = 4;
    Brick[] BricksArray;

    // Attribute

    // Konstruktor
    /**
     * Erzeugt ein neues Level
     * @param pCounter Der Counter muss bergeben werden, damit das Programm weiss, wann das Level beendet ist.
     * @param pBildschirm Der Bildschirm muss bergeben werden.
     * @param pBall Der Ball muss bergeben werden.
     * @param pLevel Das Level, das ausgefhrt werden soll.
     * @param pBalken Der Balken soll bergeben werden.
     */
    public Level(Counter pCounter, Bildschirm pBildschirm, Ball pBall, int pLevel, Balken pBalken)
    {
        derBildschirm = pBildschirm;
        derBalken = pBalken;
        derCounter = pCounter;
        numLevel = pLevel;
        derBall = pBall;
        meinStift = new Buntstift();
        switch(numLevel){
            case 1: numBricks = 21; break;
            case 2: numBricks = 18; break;
            case 3: numBricks = 30; break;
            case 4: numBricks = 28; break;
            default: numBricks = 1;
        }
        BricksArray = new Brick[numBricks];
        switch(numLevel){
            case 1:
                BricksArray[0] = new Brick(derBildschirm, 95, 150, derBall, derCounter);
                BricksArray[1] = new Brick(derBildschirm, 140, 150, derBall, derCounter);
                BricksArray[2] = new Brick(derBildschirm, 185, 150, derBall, derCounter);
                BricksArray[3] = new Brick(derBildschirm, 230, 150, derBall, derCounter);
                BricksArray[4] = new Brick(derBildschirm, 275, 150, derBall, derCounter);
                BricksArray[5] = new Brick(derBildschirm, 320, 150, derBall, derCounter);
                BricksArray[6] = new Brick(derBildschirm, 365, 150, derBall, derCounter);
                BricksArray[7] = new SmallerBrick(derBildschirm, 95, 170, derBall, derCounter, derBalken);
                BricksArray[8] = new Brick(derBildschirm, 140, 170, derBall, derCounter);
                BricksArray[9] = new Brick(derBildschirm, 185, 170, derBall, derCounter);
                BricksArray[10] = new Brick(derBildschirm, 230, 170, derBall, derCounter);
                BricksArray[11] = new Brick(derBildschirm, 275, 170, derBall, derCounter);
                BricksArray[12] = new Brick(derBildschirm, 320, 170, derBall, derCounter);
                BricksArray[13] = new SizeBrick(derBildschirm, 365, 170, derBall, derCounter, derBalken);
                BricksArray[14] = new SizeBrick(derBildschirm, 95, 130, derBall, derCounter, derBalken);
                BricksArray[15] = new Brick(derBildschirm, 140, 130, derBall, derCounter);
                BricksArray[16] = new Brick(derBildschirm, 185, 130, derBall, derCounter);
                BricksArray[17] = new Brick(derBildschirm, 230, 130, derBall, derCounter);
                BricksArray[18] = new Brick(derBildschirm, 275, 130, derBall, derCounter);
                BricksArray[19] = new Brick(derBildschirm, 320, 130, derBall, derCounter);
                BricksArray[20] = new SmallerBrick(derBildschirm, 365, 130, derBall, derCounter, derBalken);
                break;
            case 2:
                BricksArray[0] = new Brick(derBildschirm, 230, 50, derBall, derCounter);
                BricksArray[1] = new Brick(derBildschirm, 270, 70, derBall, derCounter);
                BricksArray[2] = new Brick(derBildschirm, 310, 90, derBall, derCounter);
                BricksArray[3] = new Brick(derBildschirm, 350, 110, derBall, derCounter);
                BricksArray[4] = new ResetBrick(derBildschirm, 390, 130, derBall, derCounter, derBalken);
                BricksArray[5] = new FastBrick(derBildschirm, 390, 150, derBall, derCounter);
                BricksArray[6] = new Brick(derBildschirm, 350, 170, derBall, derCounter);
                BricksArray[7] = new Brick(derBildschirm, 310, 190, derBall, derCounter);
                BricksArray[8] = new Brick(derBildschirm, 270, 210, derBall, derCounter);
                BricksArray[9] = new Brick(derBildschirm, 230, 230, derBall, derCounter);
                BricksArray[10] = new Brick(derBildschirm, 190, 210, derBall, derCounter);
                BricksArray[11] = new Brick(derBildschirm, 150, 190, derBall, derCounter);
                BricksArray[12] = new Brick(derBildschirm, 110, 170, derBall, derCounter);
                BricksArray[13] = new ResetBrick(derBildschirm, 70, 130, derBall, derCounter, derBalken);
                BricksArray[14] = new SpeedBrick(derBildschirm, 70, 150, derBall, derCounter, derBalken);
                BricksArray[15] = new Brick(derBildschirm, 110, 110, derBall, derCounter);
                BricksArray[16] = new Brick(derBildschirm, 150, 90, derBall, derCounter);
                BricksArray[17] = new Brick(derBildschirm, 190, 70, derBall, derCounter);
                break;
            case 3:
                BricksArray[0] = new Brick(derBildschirm, 30, 50, derBall, derCounter);
                BricksArray[1] = new Brick(derBildschirm, 75, 50, derBall, derCounter);
                BricksArray[2] = new Brick(derBildschirm, 120, 50, derBall, derCounter);
                BricksArray[3] = new Brick(derBildschirm, 165, 50, derBall, derCounter);
                BricksArray[4] = new Brick(derBildschirm, 210, 50, derBall, derCounter);
                BricksArray[5] = new Brick(derBildschirm, 255, 50, derBall, derCounter);
                BricksArray[6] = new Brick(derBildschirm, 300, 50, derBall, derCounter);
                BricksArray[7] = new Brick(derBildschirm, 345, 50, derBall, derCounter);
                BricksArray[8] = new Brick(derBildschirm, 390, 50, derBall, derCounter);
                BricksArray[9] = new Brick(derBildschirm, 435, 50, derBall, derCounter);
                BricksArray[10] = new ResetBrick(derBildschirm, 30, 70, derBall, derCounter,derBalken);
                BricksArray[11] = new Brick(derBildschirm, 75, 70, derBall, derCounter);
                BricksArray[12] = new Brick(derBildschirm, 120, 70, derBall, derCounter);
                BricksArray[13] = new Brick(derBildschirm, 165, 70, derBall, derCounter);
                BricksArray[14] = new SuperBall(derBildschirm, 210, 70, derBall, derCounter);
                BricksArray[15] = new SuperBall(derBildschirm, 255, 70, derBall, derCounter);
                BricksArray[16] = new Brick(derBildschirm, 300, 70, derBall, derCounter);
                BricksArray[17] = new Brick(derBildschirm, 345, 70, derBall, derCounter);
                BricksArray[18] = new Brick(derBildschirm, 390, 70, derBall, derCounter);
                BricksArray[19] = new ResetBrick(derBildschirm, 435, 70, derBall, derCounter, derBalken);
                BricksArray[20] = new Brick(derBildschirm, 30, 150, derBall, derCounter);
                BricksArray[21] = new Brick(derBildschirm, 75, 150, derBall, derCounter);
                BricksArray[22] = new Brick(derBildschirm, 120, 150, derBall, derCounter);
                BricksArray[23] = new Brick(derBildschirm, 165, 150, derBall, derCounter);
                BricksArray[24] = new Brick(derBildschirm, 210, 150, derBall, derCounter);
                BricksArray[25] = new Brick(derBildschirm, 255, 150, derBall, derCounter);
                BricksArray[26] = new Brick(derBildschirm, 300, 150, derBall, derCounter);
                BricksArray[27] = new Brick(derBildschirm, 345, 150, derBall, derCounter);
                BricksArray[28] = new Brick(derBildschirm, 390, 150, derBall, derCounter);
                BricksArray[29] = new Brick(derBildschirm, 435, 150, derBall, derCounter);
                break;
            case 4:
                BricksArray[0] = new Brick(derBildschirm, 20, 170, derBall, derCounter);
                BricksArray[1] = new Brick(derBildschirm, 46, 140, derBall, derCounter);
                BricksArray[2] = new Brick(derBildschirm, 69, 320, derBall, derCounter);
                BricksArray[3] = new Brick(derBildschirm, 200, 180, derBall, derCounter);
                BricksArray[4] = new Brick(derBildschirm, 400, 50, derBall, derCounter);
                BricksArray[5] = new Brick(derBildschirm, 340, 70, derBall, derCounter);
                BricksArray[6] = new Brick(derBildschirm, 163, 17, derBall, derCounter);
                BricksArray[7] = new Brick(derBildschirm, 310, 310, derBall, derCounter);
                BricksArray[8] = new Brick(derBildschirm, 267, 110, derBall, derCounter);
                BricksArray[9] = new Brick(derBildschirm, 246, 120, derBall, derCounter);
                BricksArray[10] = new Brick(derBildschirm, 28, 315, derBall, derCounter);
                BricksArray[11] = new Brick(derBildschirm, 100, 250, derBall, derCounter);
                BricksArray[12] = new Brick(derBildschirm, 350, 144, derBall, derCounter);
                BricksArray[13] = new Brick(derBildschirm, 335, 79, derBall, derCounter);
                BricksArray[14] = new Brick(derBildschirm, 111, 111, derBall, derCounter);
                BricksArray[15] = new Brick(derBildschirm, 169, 90, derBall, derCounter);
                BricksArray[16] = new Brick(derBildschirm, 42, 181, derBall, derCounter);
                BricksArray[17] = new Brick(derBildschirm, 200, 50, derBall, derCounter);
                BricksArray[18] = new Brick(derBildschirm, 149, 167, derBall, derCounter);
                BricksArray[19] = new Brick(derBildschirm, 56, 300, derBall, derCounter);
                BricksArray[20] = new Brick(derBildschirm, 257, 100, derBall, derCounter);
                BricksArray[21] = new ResetBrick(derBildschirm, 194, 250, derBall, derCounter, derBalken);
                BricksArray[22] = new SuperBall(derBildschirm, 195, 251, derBall, derCounter);
                BricksArray[23] = new SpeedBrick(derBildschirm, 196, 252, derBall, derCounter, derBalken);
                BricksArray[24] = new SizeBrick(derBildschirm, 197, 253, derBall, derCounter, derBalken);
                BricksArray[25] = new SizeBrick(derBildschirm, 198, 254, derBall, derCounter, derBalken);
                BricksArray[26] = new FastBrick(derBildschirm, 199, 255, derBall, derCounter);
                BricksArray[27] = new SmallerBrick(derBildschirm, 200, 256, derBall, derCounter, derBalken);
            default:
                BricksArray[0] = new Brick(derBildschirm, 250, 250, derBall, derCounter);
        }
    }

    // Dienste
    /**
     * Prft, ob das Spiel beendet wurde.
     * @return True, wenn noch ein weiteres Level besteht, sonst False.
     */
    public boolean pruefe()
    {
        if(numLevel < anzLevel){
            numLevel++;
            return true;
        }else{
            return false;    
        }
    }
    /**
     * Prft, ob das Level beendet wurde.
     * @return True, wenn das Level beendet ist.
     */
    public boolean fertig(){
        if(win) return true;
        else return false;
    }
    /**
     * Prft, ob alle Bricks getroffen sind.
     */
    public void pruefeBricks(){
        for(int i=0;i < numBricks;i++){
            BricksArray[i].pruefe();
        }
        if(derCounter.Punkte() == numBricks){
             win = true;
             derBalken.loesche(); derBalken.setzeBreite(100);
             derBall.setzeSuperball(false);
             derBall.setzeFast(false);
             derBalken.setzeGeschwindigkeit(1.3);
        }
    }
    /**
     * Zeichnet alle Bricks.
     */
    public void zeichne(){
        for(int i=0;i < numBricks;i++){
            BricksArray[i].zeichne();
        }
    }
    /**
     * Schreibt das Level oben an.
     */
    public void aktualisiere(){
        meinStift.bewegeBis(250, 25);
        meinStift.radiere();
        meinStift.setzeLinienBreite(20);
        meinStift.runter();
        meinStift.bewegeUm(100);
        meinStift.hoch();
        meinStift.bewegeBis(250, 25);
        meinStift.normal();
        meinStift.setzeLinienBreite(1);
        meinStift.schreibeText("Level ");
        meinStift.schreibeZahl(numLevel);
    }
    /**
     * Gibt alle eigenen Objekte frei.
     */
    public void gibFrei(){
        win = false;
        meinStift.gibFrei();
    }
}
